



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python：Day53  Template基础</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python：Day53  Template基础</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 05:28:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、模板由 html代码+逻辑控制代码 组成</p>
<p>二、逻辑控制代码的组成</p>
<p>1、变量（使用双大括号来引用变量）</p>
<p>　　语法格式：{{ var_name }}</p>
<p>-----------------------Template和Context对象</p>
<div>
<pre class="prettyprint linenums">(venv) C:\Users\Lowry\PycharmProjects\django_template&gt;python manage.py shell<br />
&gt;&gt;&gt; from django.template import Context,Template<br />
&gt;&gt;&gt; t=Template("my name is {{name}}")    #逻辑控制代码一定要写在引号里面<br />
&gt;&gt;&gt; c=Context({'name':"alex"})<br />
&gt;&gt;&gt; t.render(c)<br />
'my name is alex'

#同一模板多个上下文<br />
1、多次创建模板<br />
&gt;&gt;&gt; for name in ("john","julie","pat"):<br />
...     t=Template("hello,{{name}}")    #缩进必须要有<br />
...     print(t.render(Context({"name":name})))<br />
...<br />
hello,john<br />
hello,julie<br />
hello,pat

2、一次创建多次渲染<br />
&gt;&gt;&gt; t=Template("my name is {{name}}")<br />
&gt;&gt;&gt; for name in ("john","alex","kobe"):<br />
...     print(t.render(Context({"name":name})))<br />
...<br />
my name is john<br />
my name is alex<br />
my name is kobe</pre>
</div>
<p>----------------------------万能句点号，用于特殊变量的取值。点后面接的是对象的属性，这个要和filter的方法区分开。</p>
<div>
<pre class="prettyprint linenums">-----------------------views<br />
import datetime

def index(request):<br />
    obj="alex"<br />
    s=[111,222,333,"alex"]<br />
    s1={"username":"alex","age":18}<br />
    s2=datetime.datetime.now()

    class person():<br />
        def __init__(self,a,b):<br />
            self.name=a<br />
            self.age=b<br />
    s3=person("yuan",18)

    return render(request,"index.html",{"name":s3})

-------------------------index.html<br />
{#{{ name }}#}<br />
{#{{ name.username }}#}<br />
{{ name.name }}<br />
{{ name.age }}</pre>
</div>
<p>2、{% if %}的使用</p>
<div>
<pre class="prettyprint linenums">{% if True %}   //if后面接的是表示True或False的对象，可以是Ture或False,也可以是字符串、数字，但字符串必须要加引号，如果不加引号解释器会认为是变量。<br />
    &lt;p&gt;hello world&lt;/p&gt;<br />
{% elif obj %}  //这个obj在这里是变量，对应视图函数中render返回中的第三个参数<br />
    &lt;p&gt;hello 2&lt;/p&gt;<br />
{% endif %}</pre>
</div>
<p>3、{% for %}的使用</p>
<div>
<pre class="prettyprint linenums">----------------------views

def index(request):<br />
    s=[111,222,333,"alex"]

    return render(request,"index.html",{"obj":s})

----------------------index.html

{% for i in obj %}<br />
    &lt;p&gt;{{ forloop.counter }}:{{ i }}&lt;/p&gt;    //结果：1:111 2:222 3:333 4:alex<br />
    &lt;p&gt;{{ forloop.counter0 }}:{{ i }}&lt;/p&gt;   //结果：0:111 1:222 2:333 3:alex<br />
    &lt;p&gt;{{ forloop.revcounter }}:{{ i }}&lt;/p&gt;     //结果：4:111 3:222 2:333 1:alex<br />
    &lt;p&gt;{{ forloop.revcounter0 }}:{{ i }}&lt;/p&gt;   //结果：3:111 2:222 1:333 0:alex<br />
{% endfor %}</pre>
</div>
<p>4、filter的使用</p>
<div>
<pre class="prettyprint linenums">语法格式：      {{obj|filter:param}}</pre>
</div>
<p>filter其实是上模板语言提供的方法，它是将前面的一个对象传到后面的方法中，有参数的在过滤器后面加冒号，然后加参数，处理过后再返回值，虽然有很多方法和python很像，但是不是python的，不要搞混。</p>
<div>
<pre class="prettyprint linenums">---------------------views

def index(request):<br />
    ret="alex"

    return render(request,"index.html",{"obj":ret})

---------------------index.html

{{ obj|upper }} //ALEX<br />
{{ obj|lower }} //alex<br />
{{ obj|first }} //a<br />
{{ obj|first|upper }}  //A<br />
{{ obj|capfirst }}  //Alex</pre>
</div>
<p>add过滤器</p>
<div>
<pre class="prettyprint linenums">---------------------------views

def index(request):<br />
    s4=6<br />
    return render(request,"index.html",{"obj":s4})

---------------------------index.html

{{ obj|add:5 }}     //结果：11</pre>
</div>
<p>cut过滤器</p>
<div>
<pre class="prettyprint linenums">--------------------------views

def index(request):<br />
    s5="hello world"<br />
    return render(request,"index.html",{"obj":s5})

--------------------------index.html

{{ obj|cut:"or" }}     //结果：hello wld,如果cut的是字符串，要记得加上引号</pre>
</div>
<p>date过滤器</p>
<div>
<pre class="prettyprint linenums">--------------------------views

def index(request):<br />
    s2=datetime.datetime.now()<br />
    return render(request,"index.html",{"obj":s2})

--------------------------index.html

{{ obj|date:"y-m-d" }}  //18-05-08,后面的格式要用引号引起来<br />
{{ obj|date:"Y-m-d" }}  //2018-05-08</pre>
</div>
<p>default过滤器：如果值是False就替换成设置的默认值，否则就是用本来的值</p>
<div>
<pre class="prettyprint linenums">-----------------------------------views

def index(request):<br />
    s6=[]<br />
    return render(request,"index.html",{"obj":s6})

-----------------------------------index.html

{{ obj|default:"空的" }}</pre>
</div>
<p>{% autoescape off%}：注意这里是加在{%　%}中的</p>
<div>
<pre class="prettyprint linenums">#没加之前的效果<br />
--------------------------------views

def index(request):<br />
    s7="&lt;a href='#'&gt;&lt;/a&gt;"<br />
    return render(request,"index.html",{"obj":s6})

--------------------------------index.html

{{ obj }}    //&lt;a href='#'&gt;跳转&lt;/a&gt;

#加过之后的效果<br />
--------------------------------views

def index(request):<br />
    s7="&lt;a href='#'&gt;&lt;/a&gt;"<br />
    return render(request,"index.html",{"obj":s6})

--------------------------------index.html

{% autoescape off %}<br />
{{ obj }}       //跳转<br />
{% endautoescape %}</pre>
</div>
<p>safe过滤器：和上面起到的效果一样，都是让浏览器去渲染这个标签</p>
<div>
<pre class="prettyprint linenums">--------------------------------views

def index(request):<br />
    s7="&lt;a href='#'&gt;&lt;/a&gt;"<br />
    return render(request,"index.html",{"obj":s6})

--------------------------------index.html

{{ obj|safe }}    //跳转</pre>
</div>
<p>其它过滤器：</p>
<div>
<pre class="prettyprint linenums">-----------------------views

def index(request):<br />
    s5="hello world"<br />
    return render(request,"index.html",{"obj":s5})

-----------------------index.html

{{ obj|filesizeformat }}    //0 bytes,为什么是0？<br />
{{ obj|length }}    //11<br />
{{ obj|slice:":-1" }}   //hello worl</pre>
</div>
<p>{% csrf_token %}：csrf_token标签</p>
<p>用于生成csrf_token的标签（其实就是一个input标签），用于防治跨站攻击验证。这个Input标签是隐藏的，名字为：csrfmiddlewaretoken，value是一堆字符串。</p>
<div>
<pre class="prettyprint linenums">-------------------------------------views

def login(request):<br />
    if request.method=="POST":<br />
        return HttpResponse("登陆成功")<br />
    return render(request,"login.html")

-------------------------------------index.html

&lt;form action="/login" method="post"&gt;<br />
    &lt;p&gt;姓名：&lt;input type="text" name="username"&gt;&lt;/p&gt;<br />
    &lt;p&gt;密码：&lt;input type="text" name="password"&gt;&lt;/p&gt;<br />
    &lt;input type="submit"&gt;<br />
    {% csrf_token %}<br />
&lt;/form&gt;</pre>
</div>
<p>这里有一点需要注意的，这个方法只适用于render，对于render_to_response不适用，如果想使用需要额外加命令。</p>
<p>{% url %}</p>
<div>
<pre class="prettyprint linenums">--------------------------------urls

urlpatterns = [<br />
    path('admin/', admin.site.urls),<br />
    path('login', views.login,name="abc"),<br />
]

--------------------------------views

def login(request):<br />
    if request.method=="POST":<br />
        return HttpResponse("登陆成功")<br />
    return render(request,"login.html")

--------------------------------login.html

&lt;form action="{% url "abc" %}" method="post"&gt;<br />
    &lt;p&gt;姓名：&lt;input type="text" name="username"&gt;&lt;/p&gt;<br />
    &lt;p&gt;密码：&lt;input type="text" name="password"&gt;&lt;/p&gt;<br />
    &lt;input type="submit"&gt;<br />
    {% csrf_token %}<br />
&lt;/form&gt;</pre>
</div>
<p>{% verbatim %}：不进行render渲染</p>
<div>
<pre class="prettyprint linenums">{% verbatim %}<br />
{{ obj }}<br />
{% endverbatim %}</pre>
</div>
<p>{% load %}：在HTML文件中加载自定义的simple_tag和filter时用的。</p>
<p>自定义simple_tag和filter</p>
<p>1、在app中创建templatetags文件夹或包</p>
<p>2、在templatetags中创建.py文件</p>
<div>
<pre class="prettyprint linenums">from django import template<br />
from django.utils.safestring import mark_safe

register = template.Library()   #register的名字是固定的,不可改变

@register.simple_tag<br />
def myadd(v1):<br />
    return v1+1001

@register.filter<br />
def myplus(v1,v2):<br />
    return v1+v2</pre>
</div>
<p>3、在HTML文件中引入py文件，然后进行调用</p>
<div>
<pre class="prettyprint linenums">{% load my_tags %}    可以在HTML最上面，可以不在

{% myadd 1 %}    #simple_tag用{% %}包着

{{ num|myplus:12 }}    #filter和其它自带filter一样都是用{{ }}包着</pre>
</div>
<p>4、一定要在settings中的INSTALL_APPS配置当前app，不然Django无法找到文件</p>
<p>注意：filter中最多只能有两个参数，而simple_tag中可以多个，但是simple_tag不能用在for或if后面，而filter可以</p>
<div>
<pre class="prettyprint linenums">{% if num|myplus:20 &gt; 100 %}<br />
    &lt;h1&gt;大于100 &lt;/h1&gt;<br />
{% endif %}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r3wgr9.html">ADB连不上&comma;ADB server didn&amp;&num;39&semi;t ACK问题&comma;的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmnx69.html">python&colon;  html</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oknpel9.html">SlickGrid example 7&colon;鼠标事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wwepxq.html">android入门之&colon; SharedPreferences</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y4jyeq.html">js 调用IE内置打印控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm511z9.html">Python开发【第一篇】Python基础之自定义模块和内置模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwmox9.html">How to Diagnose Audi Vehicles via Tuirel S777</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0447lq.html">DataTable数据与Excel表格的相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydepkmq.html">USB VID PID 查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpm0wj9.html">【Loadrunner】初学Loadrunner&mdash;&mdash;参数化设置（Table类型关联数据库）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj03z9.html">SQL SERVER 的前世今生--各版本功能对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kon049.html">Spring Security入门（1-9）Spring Security 的xml 命名空间配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg275e8.html">TensorFlow从1到2（六）结构化数据预处理和心脏病预测</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk7r7z8.html">Python-写文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jooxw8.html">Django REST framework框架介绍和基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgo6xr8.html">Openresty安装及使用配置（OPENRESTY&plus;NGINX）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw1x7y8.html">Tomcat学习总结（2）&mdash;&mdash;Tomcat使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027rmmq.html">git pull与本地修改冲突</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve24wx9.html">【Unity】12&period;3 Off Mesh Link组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn1o0dq.html">2017年值得一看的7个APP设计</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7oemxg8.html">sqlplus导入数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2n7e9.html">ES6新特性概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1mz3g9.html">洛谷P4593 &lbrack;TJOI2018&rsqb;教科书般的亵渎&lpar;拉格朗日插值&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1jg0q.html">loj&num;6029&period; 「雅礼集训 2017 Day1」市场&lpar;线段树&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyvymmq.html">GIS开发之数据查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4mmge9.html">Android为TV端助力 转载：android MVC设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oe77g8.html">ajax post 提交数据和文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvlonr8.html">Visual Stuido Online：如何禁止多人同时签出同一文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oel7g8.html">在Win32程序中嵌入Edge浏览器组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2jpmrq.html">第一次使用VS Code时你应该知道的一切配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
